/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.service.impl;

import com.rjconsultores.ventaboletos.dao.PricingCorridaDAO;
import com.rjconsultores.ventaboletos.entidad.CorridaCtrl;
import com.rjconsultores.ventaboletos.entidad.Pricing;
import com.rjconsultores.ventaboletos.entidad.PricingCorrida;
import com.rjconsultores.ventaboletos.service.PricingCorridaService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;
import java.util.Calendar;
import java.util.List;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

/**
 *
 * @author Rafius
 */
@Service("pricingCorridaService")
public class PricingCorridaServiceImpl implements PricingCorridaService {

    @Autowired
    private PricingCorridaDAO pricingCorridaDAO;

    public List<PricingCorrida> obtenerTodos() {
        return pricingCorridaDAO.obtenerTodos();
    }

    public PricingCorrida obtenerID(Integer id) {
        return pricingCorridaDAO.obtenerID(id);
    }

    @Transactional
    public PricingCorrida suscribir(PricingCorrida entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Pricing.ATIVO);

        return pricingCorridaDAO.suscribir(entidad);
    }

    @Transactional
    public PricingCorrida actualizacion(PricingCorrida entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Pricing.ATIVO);

        return pricingCorridaDAO.actualizacion(entidad);
    }

    @Transactional
    public void borrar(PricingCorrida entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Pricing.EXCLUIDO);

        pricingCorridaDAO.actualizacion(entidad);
    }

    public Boolean obtenerPricingCorrida(Pricing pricing, CorridaCtrl corrida) {
        return pricingCorridaDAO.obtenerPricingCorrida(pricing, corrida);
    }

	@Override
	@Transactional
	public void borrar(List<PricingCorrida> pricingCorridas) {
		if(pricingCorridas != null && !pricingCorridas.isEmpty()) {
			for (PricingCorrida pricingCorrida : pricingCorridas) {
				borrar(pricingCorrida);
			}
		}
	}
}
